/*****************************************************************************
 *
 *  Terrible little API tester.                    { Ver 0.01 10/24/96 }
 *
 *****************************************************************************/

#include <stdio.h>
#include <string.h>
#include <strings.h>
#include <ctype.h>
#include <math.h>

#ifdef CIB_UNIX
#include <curses.h>
#else 
#include <conio.h>
#include <process.h>
#include <windows.h>
#endif 

#include "cibapi.h"

#ifndef TRUE
#define TRUE  1
#define FALSE 0
#endif

char *MenuStrings[] =
{
   "0.  Exit               1.  Set common PIN            2.  Master erase   ",
   "3.  Create group       4.  Set group PIN             5.  Create object  ",
   "6.  Lock object        7.  Privatize object          8.  Destruct obj   ",
   "9.  Lock CiB           10. Lock Group                11. Invoke script  ",
   "12. Read object        13. Write object              14. Read group name",
   "15. Delete group       16. Get group ID              17. Get config info",
   "18. Read RTC           19. Read true time clock      20. Check group crc",
   "21. Get Random bytes   22. Get firmware ver.         23. Get free RAM   ",
   "24. Change group name  25. Disable key set gen       26. Gen RSA key set",
   "27. Gen RSA mod, exp   28. Gen KS no private         29. Generate prime "
};

void Center(BYTE y, char *TextStr)
{
#ifndef CIB_UNIX
   gotoxy((80 - strlen(TextStr)) >> 1, y); 
   printf("%s\n", TextStr);
#else
   printf("%s\n", TextStr);
#endif
}

void DisplayMenu(void)
{
   BYTE i, y;

#ifndef CIB_UNIX
   clrscr();
#else
   printf("\n\n-----------------------------------------------\n\n");
#endif 

   Center(1, "Miac command set");

   y = 3;

   for (i = 0; i < 10; i++)
      Center(y++, &MenuStrings[i][0]);

   Center(++y, "Selection: ");
}

/*
 *    This function get a block of text from stdout and returns the number
 * of characters received. MaxLen is the maximum number of characters
 * desired.  The array pointed to by TextStr will have MaxLen characters
 * initialized to 0.
 */
BYTE GetText(BYTE MaxLen, char *TextStr)
{
   char Temp[256];
   BYTE n;

   memset(TextStr, 0, MaxLen);
   scanf("%s", Temp);
   
   n = (strlen(Temp) < MaxLen) ? strlen(Temp) : MaxLen;

   memcpy(TextStr, Temp, n);
   TextStr[n] = 0;

   return strlen(TextStr);
}

WORD GetSelection(void)
{
   BYTE TStr[2];

   GetText(2, (char *) TStr);

   if (TStr[1])
      return (TStr[1] - '0') + 10 * (TStr[0] - '0');
   else
      return TStr[0] - '0';
}

int pow10m(int p)
{
   int i, x;

   x = 1;
   if (x < 4)
      for (i = 0; i < p; i++)
         x *= 10;

   return x;
}

BYTE GetByte(void)
{
   BYTE TStr[4] = { 0, 0, 0, 0 }, i;
   WORD x = 0;

   GetText(3, (char *)TStr);

   for (i = 0; i < strlen((char *)TStr); i++)
      if (TStr[i])
         x += (TStr[i] - '0') * (BYTE) pow10m(strlen((char *)TStr) - i - 1);

   return x % 256;
}

void DumpRetPacket(LPRETPACKET lpRP)
{
   BYTE i, j, x, y, ch, ks[2];

   printf("\nReturn status = %2.2XH\n", lpRP->CSB);
   printf("Return group ID = %2.2XH\n", lpRP->GroupID);
   printf("Output data length = %2.2XH\n", lpRP->DataLen);

   if (lpRP->DataLen)
   {
      printf("Dump output data (y or n) ? : ");
      GetText(1, (char *) &ch);

      if (toupper(ch) == 'Y')
      {
         printf("\n");

         x = lpRP->DataLen >> 4;
         y = lpRP->DataLen % 16;

         for (i = 0; i < x; i++)
         {
            for (j = 0; j < 16; j++)
               printf("%2.2X ", lpRP->CmdData[(i << 4) + j]);

            for (j = 0; j < 16; j++)
            {
               if (lpRP->CmdData[(i << 4) + j] < 0x20)
                  putchar('.');
               else
                  putchar(lpRP->CmdData[(i << 4) + j]);
            }

            printf("\n");
         }

         if (y)
         {
            for (i = 0; i < y; i++)
               printf("%2.2X ", lpRP->CmdData[(x << 4) + i]);

            for (i = 0; i < 16 - y; i++)
               printf("   ");

            for (i = 0; i < y; i++)
            {
               if (lpRP->CmdData[(x << 4) + i] < 0x20)
                  putchar('.');
               else
                  putchar(lpRP->CmdData[(x << 4) + i]);
            }
         }
      }
   }

   printf("\n\nPress c <enter> key to continue ...");
   scanf("%1s", ks); 
}

void DumpError(void)
{
   char ks[2];
   printf("\n\n........ ERROR = %4.4X\n", GetCiBError());

   printf("\n\nPress c <enter> key to continue ...");
   scanf("%1s", ks); 

}

int main()
{
   RETPACKET RP;
   CIBOBJ    MObject;
   LPBYTE    CiBROMPtr;
   BYTE      GroupID, ObjectID, CiBNum, Attr;
   BYTE      ModulusID, PublicExpID, PrivateExpID;
   BYTE      ModulusSize;
   CIBPIN    CommonPIN, GroupPIN;
   CIBNAME   GroupName;
   DWORD     NumSeconds;
   BIGNUM    Prime;
   BYTE      PrimeSize;
   BYTE      OptionByte;
   CIBPIN    OldCommonPIN, NewCommonPIN;
   BYTE      GroupAttr;
   CIBPIN    OldGroupPIN, NewGroupPIN;
   CIBOBJ    NewObject;
   BYTE      ByteNum, RandomBuff[128];
   WORD      FreeRAMBytes;
   CIBNAME   VersionString;
   CIBINFO   ConfigInfo;
   WORD      i, Sel = 1;
   char      *DeviceNames[] = { "/dev/ttya" };
   char      ch;

   /* Tell the API which serial ports to search */
   SetCiBSearchParams(1, DeviceNames);
   /* Find all CiB's on all adapters */
   CiBROMPtr = FindCiBs(&CiBNum);

   if (CiBNum)
   {
      /* Just talk to the 1st CiB we find */
      SelectCiB(CiBROMPtr);

      while (Sel)
      {
         DisplayMenu();
         Sel = GetSelection();

         switch (Sel)
         {
            case 0:

            break;

            case SET_COMMON_PIN:
               printf("\nEnter old PIN : ");
               /* Get old PIN data */
               OldCommonPIN.Len = (BYTE) GetText(8, OldCommonPIN.PINData);

               printf("\nEnter new PIN : ");
               /* Get new PIN data */
               NewCommonPIN.Len = (BYTE) GetText(8, NewCommonPIN.PINData);

               OptionByte = 0;
               /* Get option byte */
               printf("\nRequire PIN for master erase (y or n) : ");
               GetText(1, &ch);

               if (toupper(ch) == 'Y')
                  OptionByte |= PIN_TO_ERASE;

               /* Get option byte */
               printf("\nRequire PIN for group creation (y or n) : ");
               GetText(1, &ch);

               if (toupper(ch) == 'Y')
                  OptionByte |= PIN_TO_CREATE;

               if (SetCommonPIN(&OldCommonPIN,
                                &NewCommonPIN,
                                OptionByte,
                                &RP))
               {
                  DumpRetPacket(&RP);
               }
               else
                  DumpError();
            break;

            case MASTER_ERASE:
               printf("\nEnter Common PIN :");
               CommonPIN.Len = (BYTE) GetText(8, (char *)CommonPIN.PINData);

               if (MasterErase(&CommonPIN, &RP))
                  DumpRetPacket(&RP);
               else
                  DumpError();
            break;

            case CREATE_TRANSACTION_GROUP:
               printf("\nEnter common PIN : ");
               CommonPIN.Len = GetText(8, (char *)CommonPIN.PINData);
               printf("\nEnter new group name : ");
               GroupName.Len = GetText(16, (char *)GroupName.NameData);
               printf("\nEnter new group PIN : ");
               GroupPIN.Len = GetText(8, (char *)GroupPIN.PINData);

               /* Reserved */
               GroupAttr = 0;

               if (CreateTransactionGroup(&CommonPIN,
                                          &GroupName,
                                          &GroupPIN,
                                          GroupAttr,
                                          &GroupID,
                                          &RP))
               {
                  printf("\n\nNew group ID=%d", GroupID);
                  DumpRetPacket(&RP);
               }
               else
                  DumpError();
            break;

            case SET_GROUP_PIN:
               printf("\nEnter group ID: ");
               GroupID = GetSelection();

               printf("\nEnter old group PIN: ");
               OldGroupPIN.Len = GetText(8, (char *)OldGroupPIN.PINData);
               printf("\nEnter new group PIN: ");
               NewGroupPIN.Len = GetText(8, (char *)NewGroupPIN.PINData);

               if (SetGroupPIN(GroupID,
                               &OldGroupPIN,
                               &NewGroupPIN,
                               &RP))
               {
                  DumpRetPacket(&RP);
               }
               else
                  DumpError();
            break;

            case CREATE_OBJECT:
               printf("\nEnter group ID: ");
               GroupID = GetSelection();
               printf("\nEnter group PIN: ");
               GroupPIN.Len = GetText(8, (char *)GroupPIN.PINData);

               NewObject.Attr = 0;

               /* Get locked bit */
               printf("\nLocked object (y or n) ? ");
               GetText(1, &ch);
               if (toupper(ch) == 'Y')
                  NewObject.Attr |= LOCKED;

               /* Get private bit */
               printf("\nPrivate object (y or n) ? ");
               GetText(1, &ch);
               if (toupper(ch) == 'Y')
                  NewObject.Attr |= PRIVATE;

               /* Get destruct bit */
               printf("\nDestructable object (y or n) ? ");
               GetText(1, &ch);
               if (toupper(ch) == 'Y')
                  NewObject.Attr |= DESTRUCT;

               printf("\nEnter object type: ");
               NewObject.Type = GetSelection();

               /* Get object length and data */
               printf("\nEnter object data : ");
               NewObject.Len = GetText(128, (char *)NewObject.ObjData);

               if (CreateCiBObject(GroupID,
                                   &GroupPIN,
                                   &NewObject,
                                   &ObjectID,
                                   &RP))
               {
                  printf("\nReturn object id=%d", ObjectID);
                  DumpRetPacket(&RP);
               }
               else
                  DumpError();
            break;

            case PRIVATIZE_OBJECT:
            case LOCK_OBJECT:
            case DESTRUCTIBLE_OBJECT:
               printf("\nEnter group ID: ");
               GroupID = GetSelection();
               printf("\nEnter group PIN: ");
               GroupPIN.Len = GetText(8, (char *)GroupPIN.PINData);
               printf("\nEnter object ID: ");
               ObjectID = GetSelection();

               Attr = LOCKED;
               if (Sel == PRIVATIZE_OBJECT)
               {
                  Attr = PRIVATE;
               }
               else
               {
                  if (Sel == DESTRUCTIBLE_OBJECT)
                  {
                     Attr = DESTRUCT;
                  }
               }

               if (SetCiBObjectAttr(GroupID,
                                    &GroupPIN,
                                    ObjectID,
                                    Attr,
                                    &RP))
               {
                  DumpRetPacket(&RP);
               }
               else
                  DumpError();
            break;

            case LOCK_CIB:
               printf("\nEnter common PIN : ");
               CommonPIN.Len = GetText(8, (char *)CommonPIN.PINData);

               if (LockCiB(&CommonPIN, &RP))
                  DumpRetPacket(&RP);
               else
                  DumpError();
            break;

            case LOCK_GROUP:
               printf("\nEnter group ID: ");
               GroupID = GetSelection();
               printf("\nEnter group PIN: ");
               GroupPIN.Len = GetText(8, (char *)GroupPIN.PINData);

               if (LockGroup(GroupID, &GroupPIN, &RP))
                  DumpRetPacket(&RP);
               else
                  DumpError();
            break;

            case READ_OBJECT:
               printf("\nEnter group ID: ");
               GroupID = GetSelection();
               printf("\nEnter group PIN: ");
               GroupPIN.Len = GetText(8, (char *)GroupPIN.PINData);
               printf("\nEnter object ID: ");
               ObjectID = GetSelection();

               if (ReadCiBObject(GroupID,
                                 &GroupPIN,
                                 ObjectID,
                                 &MObject,
                                 &RP))
               {
                  /* I should examine MObject structure seperately here ! */

                  DumpRetPacket(&RP);
               }
               else
                  DumpError();
            break;

            case WRITE_OBJECT:
               printf("\nEnter group ID: ");
               GroupID = GetSelection();
               printf("\nEnter group PIN: ");
               GroupPIN.Len = GetText(8, (char *)GroupPIN.PINData);
               printf("\nEnter object ID: ");
               ObjectID = GetSelection();

               /* Get object length and data */
               printf("\nEnter object data : ");
               MObject.Len = GetText(128, (char *)MObject.ObjData);

               if (WriteCiBObject(GroupID,
                                  &GroupPIN,
                                  ObjectID,
                                  &MObject,
                                  &RP))
               {
                  DumpRetPacket(&RP);
               }
               else
                  DumpError();
            break;

            case INVOKE_SCRIPT:
               printf("\nEnter group ID: ");
               GroupID = GetSelection();
               printf("\nEnter group PIN: ");
               GroupPIN.Len = GetText(8, (char *)GroupPIN.PINData);
               printf("\nEnter object ID: ");
               ObjectID = GetSelection();

               if (InvokeScript(GroupID, &GroupPIN, ObjectID, 1000, &RP))
                  DumpRetPacket(&RP);
               else
                  DumpError();
            break;

            case DELETE_GROUP:
               printf("\nEnter group ID: ");
               GroupID = GetSelection();
               printf("\nEnter group PIN: ");
               GroupPIN.Len = GetText(8, (char *)GroupPIN.PINData);

               if (DeleteGroup(GroupID, &GroupPIN, &RP))
                  DumpRetPacket(&RP);
               else
                  DumpError();
            break;

            case READ_GROUP_NAME:
               printf("\nEnter group ID: ");
               GroupID = GetSelection();

               if (ReadGroupName(GroupID, &GroupName, &RP))
               {
                  GroupName.NameData[GroupName.Len] = 0;
                  printf("\n\nGroupName=%s\n", GroupName.NameData);
                  DumpRetPacket(&RP);
               }
               else
                  DumpError();
            break;

            case CHANGE_GROUP_NAME:
               printf("\nEnter group ID: ");
               GroupID = GetSelection();
               printf("\nEnter group PIN: ");
               GroupPIN.Len = GetText(8, (char *)GroupPIN.PINData);
               printf("\nEnter new group name : ");
               GroupName.Len = GetText(16, (char *)GroupName.NameData);

               if (ChangeGroupName(GroupID, &GroupPIN, &GroupName, &RP))
                  DumpRetPacket(&RP);
               else
                  DumpError();
            break;

            case GET_GROUP_ID:
               printf("\nEnter group name : ");
               GroupName.Len = GetText(16, (char *)GroupName.NameData);

               if (GetGroupID(&GroupName, &GroupID, &RP))
               {
                  printf("\nGroup ID=%d\n", GroupID);
                  DumpRetPacket(&RP);
               }
               else
                  DumpError();
            break;

            case CHECK_GROUP_CRC:
               printf("\nEnter group ID: ");
               GroupID = GetSelection();

               if (CheckGroupCRC(GroupID, &RP))
                  DumpRetPacket(&RP);
               else
                  DumpError();
            break;

            case GET_RANDOM_DATA:
               printf("\nEnter desired number of random bytes: ");
               ByteNum = GetByte();

               if (ReadRandomBytes(ByteNum, RandomBuff, &RP))
                  DumpRetPacket(&RP);
               else
                  DumpError();
            break;

            case READ_FREE_RAM:
               if (ReadFreeRAM(&FreeRAMBytes, &RP))
               {
                  printf("\nFree RAM=%4.4X\n", FreeRAMBytes);
                  DumpRetPacket(&RP);
               }
               else
                  DumpError();
            break;

            case READ_REAL_TIME_CLOCK:
               if (ReadRealTimeClock(&NumSeconds, &RP))
               {
                  printf("\nClock value =%8.8lX\n", NumSeconds);
                  DumpRetPacket(&RP);
               }
               else
                  DumpError();
            break;

            case READ_TRUE_TIME_CLOCK:
               printf("\nEnter group ID: ");
               GroupID = GetSelection();
               printf("\nEnter group PIN: ");
               GroupPIN.Len = GetText(8, (char *)GroupPIN.PINData);
               printf("\nEnter object ID: ");
               ObjectID = GetSelection();

               if (ReadTrueTimeClock(GroupID,
                                     &GroupPIN,
                                     ObjectID,
                                     &NumSeconds,
                                     &RP))
               {
                  printf("\nClock value =%8.8lX\n", NumSeconds);
                  DumpRetPacket(&RP);
               }
               else
                  DumpError();
            break;

            case GET_VER_STRING:
               if (ReadFirmwareVersionID(&VersionString, &RP))
               {
                  VersionString.NameData[VersionString.Len] = 0;
                  printf("\n\nVersion ID=%s\n", VersionString.NameData);
                  DumpRetPacket(&RP);
               }
               else
                  DumpError();
            break;

            case READ_CONFIG_INFO:
               if (GetCiBConfiguration(&ConfigInfo, &RP))
               {
                  printf("\nNumber of groups=%d", ConfigInfo.GroupNum);
                  printf("\nFlag byte=%d", ConfigInfo.CiBFlags);
                  DumpRetPacket(&RP);
               }
               else
                  DumpError();
            break;

            case DISABLE_KS_GEN:
               printf("\nEnter Common PIN :");
               CommonPIN.Len = (BYTE) GetText(8, (char *)CommonPIN.PINData);

               if (DisableKeySetGeneration(&CommonPIN, &RP))
                  DumpRetPacket(&RP);
               else
                  DumpError();
            break;

            case GEN_PRIME:
               printf("\nEnter group ID: ");
               GroupID = GetSelection();
               printf("\nEnter group PIN: ");
               GroupPIN.Len = GetText(8, (char *)GroupPIN.PINData);
               printf("\nEnter size in bytes: ");
               PrimeSize = GetByte();

               if (GeneratePrime(GroupID, &GroupPIN, PrimeSize, &Prime, &RP))
               {
                  printf("\n");
                  for (i = PrimeSize; i != 0; --i)
                     printf("%2.2X", Prime.NumArr[i-1]);
                  printf("\n");

                  DumpRetPacket(&RP);
               }
               else
                  DumpError();
            break;

            case GEN_RSA_KS:
               printf("\nEnter group ID: ");
               GroupID = GetSelection();
               printf("\nEnter group PIN: ");
               GroupPIN.Len = GetText(8, (char *)GroupPIN.PINData);
               
               printf("\nEnter modulus size in bytes: ");
               ModulusSize = GetByte();

               if (GenerateRSAKeySet(GroupID,
                                     &GroupPIN,
                                     ModulusSize,
                                     &ModulusID,
                                     &PublicExpID,
                                     &PrivateExpID,
                                     &RP))
               {
                  printf("\nModulus ID=%d", ModulusID);
                  printf("\nPublic exponent ID=%d", PublicExpID);
                  printf("\nPrivate exponent ID=%d", PrivateExpID);

                  DumpRetPacket(&RP);
               }
               else
                  DumpError();
            break;

            case GEN_RSA_KS_NO_PRIVATE:
               printf("\nEnter group ID: ");
               GroupID = GetSelection();
               printf("\nEnter group PIN: ");
               GroupPIN.Len = GetText(8, (char *)GroupPIN.PINData);

               printf("\nEnter modulus size in bytes: ");
               ModulusSize = GetByte();

               if (GenerateRSAKeySetNP(GroupID,
                                       &GroupPIN,
                                       ModulusSize,
                                       &ModulusID,
                                       &PublicExpID,
                                       &PrivateExpID,
                                       &RP))
               {
                  printf("\nModulus ID=%d", ModulusID);
                  printf("\nPublic exponent ID=%d", PublicExpID);
                  printf("\nPrivate exponent ID=%d", PrivateExpID);

                  DumpRetPacket(&RP);
               }
               else
                  DumpError();
            break;

            case GEN_RSA_MOD_AND_EXP:

            break;

            default:
               putchar(7);
         }
      }
   }
   else
      printf("Couldn't find any CiBs\n");

   return 0;
}
