/****************************************************************************
 *
 * cibcrypt.h                                      { Ver 0.00 12/5/96 }
 * (DWL)
 *
 ***************************************************************************/

#include "cibtypes.h"
#include "cibapi.h"

#ifdef WIN32
#define DLLEXPORT __stdcall
#endif

/*
 *   Object Ids for 'Dallas Primary' Demo group
 */
#define RSA_EXP_PUB       1
#define RSA_MOD           2
#define RSA_EXP_PRV       3
#define INPUT_DATA        4
#define DECRYPT_SCRIPT    0x0D 
#define RECIPIENT_MOD     0x0B 
#define RECIPIENT_EXP_PUB 0x0A 
#define ENCRYPT_SCRIPT    0x0E 
#define ENCRYPT_SAME_KEY  0x0C 
#define OUTPUT_DATA       160

/*
 *   Group/Algorithm specific defines
 */
#define KEY_LEN   16
#define MOD_LEN   128 
#define BLOCK_LEN 8

/*
 *   CiBCrypt error codes
 */
#define COMM_STATE_BAD  0x400
#define GROUP_NOT_FOUND 0x401
#define MULTIPLE_CIBS   0x402
#define KEY_DATA_BAD    0x403
#define CHECK_SUM_BAD   0x404

/*
 *   Script run time in ms.
 */
#define ENCRYPT_SCRIPT_RUN_TIME 250
#define DECRYPT_SCRIPT_RUN_TIME 1500

#ifdef __cplusplus
extern "C" {
#endif

/*
 *   CiBCrypt exported functions.
 */
WORD DLLEXPORT InitializeCiB(BYTE, char **);
WORD DLLEXPORT ReadPublicKey(LPWORD, LPBYTE, LPWORD, LPBYTE, BYTE, LPBYTE);
WORD DLLEXPORT EncryptMessage(LPDWORD, LPBYTE, LPBYTE, LPBYTE, BYTE, LPBYTE, 
                              BYTE, LPBYTE, BYTE, LPBYTE);
WORD DLLEXPORT DecryptMessage(LPDWORD, LPBYTE, WORD, LPBYTE, BYTE, LPBYTE);
WORD DLLEXPORT EncryptMessageSamePub(LPDWORD, LPBYTE, LPBYTE, LPBYTE, 
                                     BYTE, LPBYTE);

#ifdef __cplusplus
}
#endif


